#!/bin/bash -e
###############################################################################

set -o pipefail

###############################################################################

hash env
hash cgi-fcgi

###############################################################################

if [ "${1}" == "readiness" ]; then
  FCGI_PORT="9000"
elif [ "${1}" == "liveness" ]; then
  FCGI_PORT="9001"
else
  exit 1
fi

###############################################################################

FCGI_HOST="localhost"

###############################################################################

REQUEST_METHOD="GET"
SCRIPT_NAME="/healthz"
SCRIPT_FILENAME="${SCRIPT_NAME}"

###############################################################################

FCGI_RESPONSE="$(
  env -i                               \
  REQUEST_METHOD="${REQUEST_METHOD}"   \
  SCRIPT_NAME="${SCRIPT_NAME}"         \
  SCRIPT_FILENAME="${SCRIPT_FILENAME}" \
  cgi-fcgi -bind -connect "${FCGI_HOST}:${FCGI_PORT}"
)"

###############################################################################

FCGI_STATUS="$(tail -n 1 <<< "${FCGI_RESPONSE}")"

###############################################################################

if [ "${FCGI_STATUS}" == "imok" ]; then exit 0; else exit 1; fi

###############################################################################
